function funct_nsdsetup {

echo ""
cecho "---------------------------------------------" $boldyellow
echo ""

read -p "Enter domain name you want to add to NSD (without www. prefix): " vhostdomainname

echo ""

read -p "Enter IP address you want to assign to domain name: " vhostdomainip

echo "---------------------------------------------------------"
echo "You entered domain name: $vhostdomainname"
echo "You entered domain IP address: $vhostdomainip"
echo "---------------------------------------------------------"

echo ""
read -p "Are the domain name and IP address entered correct ? [y/n]: " domaininfocorrect

if [[ "$domaininfocorrect" = [yY] ]]; then

vhostdomainname="$vhostdomainname"
vhostdomainip="$vhostdomainip"

echo ""
echo "-------------------------"
echo "Nameserver ns1/ns2 setup:"
echo "-------------------------"

echo ""

read -p "* Enter IP address for ns1 nameserver: " nameserverip1

echo ""

read -p "* Enter IP address for ns2 nameserver: " nameserverip2

echo "--------------------------------------------------------------"
echo "You entered ns1.$vhostdomainname IP address: $nameserverip1"
echo "You entered ns2.$vhostdomainname IP address: $nameserverip2"
echo "--------------------------------------------------------------"

echo ""
read -p "Are the ns1/ns2 name server IP address entered correct ? [y/n]: " nscorrect

if [[ "$nscorrect" = [yY] ]]; then

echo ""

##########################################
# check if zone already exists 

NSDCONFDOMAINCHECK=`grep -E '("${vhostdomainname}"|"master/${vhostdomainname}.zone")' /etc/nsd/nsd.conf`

cecho "---------------------------------------------" $boldyellow
echo "checking to see if entry for ${vhostdomainname} already exists in /etc/nsd/nsd.conf"
cecho "---------------------------------------------" $boldyellow
echo ""

if [[ -z $NSDCONFDOMAINCHECK ]]; then

cecho "---------------------------------------------" $boldyellow
echo "no entry for ${vhostdomainname} found in /etc/nsd/nsd.conf"
echo "creating entry for ${vhostdomainname} ..."
cecho "---------------------------------------------" $boldyellow
echo ""

# Setting up nsd.conf entry
cat >> "/etc/nsd/nsd.conf" <<END

zone:
        name: "$vhostdomainname"
        zonefile: "master/$vhostdomainname.zone"
END

cat /etc/nsd/nsd.conf

else

cecho "---------------------------------------------" $boldyellow
echo "entry for ${vhostdomainname} already exists in /etc/nsd/nsd.conf"
echo "$NSDCONFDOMAINCHECK"
cecho "---------------------------------------------" $boldyellow
echo ""

fi

if [ ! -f /etc/nsd/master/${vhostdomainname}.zone ]; then

touch /etc/nsd/master/${vhostdomainname}.zone

cat > "/etc/nsd/master/${vhostdomainname}.zone" <<END
\$TTL 14400
@       IN      SOA     ns1.$vhostdomainname.      hostmaster.$vhostdomainname. (
                                                2010091500
                                                14400
                                                3600
                                                1209600
                                                86400 )

; Nameservers
$vhostdomainname.       14400   IN      NS      ns1.$vhostdomainname.
$vhostdomainname.       14400   IN      NS      ns2.$vhostdomainname.

; A Records
$vhostdomainname.       14400   IN      A       $vhostdomainip
ftp                     14400   IN      A       $vhostdomainip
localhost       14400   IN      A       127.0.0.1
mail            14400   IN      A       $vhostdomainip
ns1                     14400   IN      A       $nameserverip1
ns2                     14400   IN      A       $nameserverip2
pop                     14400   IN      A       $vhostdomainip
smtp            14400   IN      A       $vhostdomainip
www                     14400   IN      A       $vhostdomainip

; MX Record
$vhostdomainname.       14400   IN      MX      10 mail

; TXT Record (for SPF)
$vhostdomainname.       14400   IN      TXT     "v=spf1 a mx ip4:$vhostdomainip ~all"
END

cecho "---------------------------------------------" $boldyellow
service nsd restart

echo 
cecho "---------------------------------------------" $boldyellow
cecho "Creating zone file at /etc/nsd/master/${vhostdomainname}.zone" $boldwhite
cecho "---------------------------------------------" $boldyellow

cat /etc/nsd/master/${vhostdomainname}.zone

echo
cecho "---------------------------------------------" $boldyellow
cecho "Current zone files listing at: /etc/nsd/master/" $boldwhite

ls -Alhrt /etc/nsd/master/ | awk '{ printf "%-4s%-4s%-8s%-6s %s\n", $6, $7, $8, $5, $9 }'

cecho "---------------------------------------------" $boldyellow

echo 
cecho "---------------------------------------------" $boldyellow
cecho "NSD entry for $vhostdomainname created successfully in /etc/nsd/nsd.conf" $boldwhite
cecho "NSD zone created at /etc/nsd/master/${vhostdomainname}.zone" $boldwhite
echo 
cecho "---------------------------------------------" $boldyellow
echo "Remember to check your domain name's DNS is properly configured"
echo "at both your domain registrar & web server end (NSD) by running" 
echo "domain name through these 3 dns test sites"
echo "* http://www.dnsvalidation.com/"
echo "* http://www.intodns.com/"
echo "* http://dnscheck.pingdom.com/"
cecho "---------------------------------------------" $boldyellow

exit

else

echo ""
cecho "---------------------------------------------" $boldyellow
#cecho "NSD entry for $vhostdomainname already exists in /etc/nsd/nsd.conf" $boldwhite
cecho "/etc/nsd/master/${vhostdomainname}.zone already exists" $boldwhite
cecho "---------------------------------------------" $boldyellow
echo ""
echo ""

exit

fi # check if zone already exists 

else

echo "-------------------------------"
echo "Aborting NSD setup... try again"
echo "-------------------------------"
exit

fi # check if nameserver ip addresses correct

else

echo "-------------------------------"
echo "Aborting NSD setup... try again"
echo "-------------------------------"
exit


fi # check if domain name and ip address are correct

}
